<template>
  <card title="Список проектов">
    <prime-tab-view v-model:activeIndex="activeIndex">
      <prime-tab-panel header="Ваши проекты">
        <project-list
          v-if="activeIndex === 0"
          :is-shared="false"
          :projects="projects"
          @delete_project="deleteProject"
          @update_project="updateProject"
        />
      </prime-tab-panel>
      <prime-tab-panel header="Проекты других пользователей">
        <project-list
          v-if="activeIndex === 1"
          :projects="projects"
          :is-shared="true"
        />
      </prime-tab-panel>
    </prime-tab-view>

    <template #after-title>
      <prime-button label="Создать новый проект" @click="isEditModalOpen = true" />
    </template>

    <prime-dialog
      v-model:visible="isEditModalOpen"
      header="Создать новый проект"
      :modal="true"
    >
      <edit-project
        @close="isEditModalOpen = false"
        @create="createProject"
      />
    </prime-dialog>
  </card>
</template>

<script lang="ts">
import PrimeButton from 'primevue/button/Button.vue';
import PrimeDialog from 'primevue/dialog/Dialog.vue';
import PrimeTabPanel from 'primevue/tabpanel';
import PrimeTabView from 'primevue/tabview';
import { defineComponent } from 'vue';
import { getProjects, getProjectsShared } from '@/api/handler/projects';
import Card from '@/components/Card.vue';
import EditProject from '@/components/projects/EditProject.vue';
import ProjectList from '@/components/projects/ProjectList.vue';
import { Project, ProjectExtended } from '@/models/projects';

interface Data {
  isEditModalOpen: boolean;
  activeIndex: number;
  projects: ProjectExtended[];
}

export default defineComponent({
  name: 'projects',
  components: {
    PrimeTabPanel,
    PrimeTabView,
    Card,
    EditProject,
    ProjectList,
    PrimeDialog,
    PrimeButton,
  },
  data(): Data {
    return {
      activeIndex: 0,
      projects: [],
      isEditModalOpen: false,
    };
  },
  computed: {
    isSharedTabOpen(): boolean {
      return this.activeIndex === 1;
    },
  },
  watch: {
    activeIndex: {
      async handler() {
        let res;

        if (this.isSharedTabOpen) {
          res = await getProjectsShared();
        } else {
          res = await getProjects();
        }

        if (res.__state === 'success') {
          this.projects = res.data;
        } else {
          this.$toast.add({ severity: 'error', detail: 'Что-то пошло не так', life: 3000 });
        }
      },
      immediate: true,
    },
  },
  methods: {
    updateProject(updatedProject: Project): void {
      const index = this.projects.findIndex((project) => project.id === updatedProject.id);

      if (index === -1) {
        return;
      }
      const newProject: ProjectExtended = {
        ...this.projects[index],
        ...updatedProject,
      };

      this.projects.splice(index, 1, newProject);
    },
    deleteProject(deletedProject: ProjectExtended) {
      const index = this.projects.findIndex((project) => project.id === deletedProject.id);

      if (index === -1) {
        return;
      }

      this.projects.splice(index, 1);
    },
    createProject(project: ProjectExtended): void {
      this.projects.push(project);
    },
  },
});
</script>

<style lang="scss" scoped>
.project-cards {
  display: flex;
  flex-wrap: wrap;

  & > * {
    margin-bottom: 2rem;

    &:not(:last-child) {
      margin-right: 2rem;
    }
  }
}
</style>
